#!/usr/local/bin/perl
#^^^^^^^^^^^^^^^^^^^^  Update this to the path-to-Perl on your network
$NETWATCH_ROOT = "/home/swatch/netwatch";
#^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^  Update this also ...

#--------Should be fairly boilerplate from here on out -------------
#
# netwatch: a program to determine and display packet loss/latency
# Copyright 1998, 1999, 2000 by Alek Komarnitsky, alek@komar.org, http://www.komar.org/
# Use and distribution of this software is covered by the GNU GPL license.  
# Please see the LICENSE file and http://www.gnu.org/

require "$NETWATCH_ROOT/netwatch.ph";
# Set this to 1 for testing purposes ...
$debug = 0;

print "Content-type: text/html\n\n\n";
&ReadParse;
$host = $in{'host'};
print "host is $host and we are running on $PING_HOST end <br>" if ($debug); 
# Don't do anything if we don't know this host
if ($host eq "") {
  print "Could not find data file for $host";
  exit;
}

# Get the time for getting the report
$PING_HOST = $in{'ping'};
$DATA_DIR = "$DATA_DIR/$PING_HOST";
$filename = $in{'filename'};
$period = $in{'period'};
# Crank down the threshholds for "longer reports"
if ( $period ne "daily" ) { 
   $loss_blue = $loss_blue / 2;
   $loss_red = $loss_red / 2;
}

# Open the file for this host
print "opening $DATA_DIR/$host/$period/$filename for read" if ($debug);
open(HOST_DATA,"<$DATA_DIR/$host/$period/$filename") || die "Could not open $DATA_DIR/$host/$period/$filename: $!\n";
print "We are going to display $in{'period'} data" if ($debug); 
print <<"EOF";
 <HTML><HEAD>
 <META NAME="CONTACT" CONTENT="Komarnitsky, Alek O">
 <META NAME="SENSITIVITY" CONTENT="UNRESTRICTED">
 <TITLE>$period report for $host on $filename from $PING_HOST</TITLE></HEAD>
 <BODY BGCOLOR="#FFFFFF"><CENTER>
 <FONT SIZE="+2"><B>$period report for $host on $filename from $PING_HOST</B></FONT>
 </CENTER><P><HR><P>
 <TABLE WIDTH="100%" BORDER=0 BGCOLOR="#DDDDDD">
 <TR>
EOF
if ( $period eq "daily" ) { 
   print "<TD><B>Time -- Loss/msec</B></TD><TD><B>Time -- Loss/msec</B></TD><TD><B>Time -- Loss/msec</B></TD>";
   print "<TD><B>Time -- Loss/msec</B></TD><TD><B>Time -- Loss/msec</B></TD><TD><B>Time -- Loss/msec</B></TD>";
} else {
   print "<TD><B>Date -- Loss/msec</B></TD><TD><B>Date -- Loss/msec</B></TD>";
   print "<TD><B>Date -- Loss/msec</B></TD><TD><B>Date -- Loss/msec</B></TD>";
}
print "</TR><TR VALIGN=TOP><TD>";
while ( <HOST_DATA> ) {
   ($time, $loss, $avg ) = split(/\s+/,$_);
   $time = "<a href=\"$GET_HISTORY?ping=$PING_HOST&host=$host&period=daily&filename=$time\">$time</a>" if ( $period eq "monthly" );
   $time = "<a href=\"$GET_HISTORY?ping=$PING_HOST&host=$host&period=monthly&filename=$time\">$time</a>" if ( $period eq "yearly" );
   $status = qq(<FONT COLOR="green">$loss%\/$avg</FONT>);
   $status = qq(<FONT COLOR="blue">$loss%\/$avg</FONT>) if ($loss > $loss_blue);
   $status = qq(<FONT COLOR="red">$loss%\/$avg</FONT>) if ($loss > $loss_red);
   $status = qq(<FONT COLOR="red"><BLINK>$loss%\/$avg</BLINK></FONT>) if ($loss > 90);
   $status = qq(<FONT COLOR="red"><BLINK>N/A</BLINK></FONT>) if ($loss == -1);
   print "<B>$time -- $status</B><BR>";
   print "</TD>\n<TD>" if (($period eq "daily") && (($i++ % 16) == 15));
   print "</TD>\n<TD>" if (($period eq "monthly") && (($i++ % 8) == 7));
   print "</TD>\n<TD>" if (($period eq "yearly") && (($i++ % 3) == 2));
}
close(HOST_DATA);
print "</TR></TABLE><HR>";

if (( "$period" eq "daily" ) || ( "$period" eq "monthly" )) {
   $period2 = "monthly";
   $period2 = "yearly" if ($period eq "monthly"); 
   if ( -r "$DATA_DIR/$host/$period2" ) {
      opendir(DIR,"$DATA_DIR/$host/$period2") || die "Could not open $DATA_DIR/$host/$period2 $!\n";
      foreach $_ (readdir(DIR)) { 
         next unless (/^[0-9]/); 
         print "Click on the links below to see $period2 data<br>" if (! $notfirst); 
         print " | " if $notfirst++;
         print "<B><A href=\"$GET_HISTORY?ping=$PING_HOST&host=$host&period=$period2&filename=$_\">$_</A></B>";
      }
      closedir(DIR);
   }
   print "<hr>";
}

# Footer
print <<EOF;
 The data collected is based on $PACKETS pings to each hosts from <strong>$PING_HOST.</strong>  Packet loss of ${loss_blue}% or 
 less is consider good "<FONT COLOR="green">GREEN</FONT>", loss of greater than
 ${loss_red}% bad "<FONT COLOR="red">RED</FONT>", and anything in between as questionable
 "<FONT COLOR="blue">BLUE</FONT>". Packet Delay is the number of milli-seconds it 
 took the pings to "acked" by the target host.
 The data above is the $period average based on polling of every $update_interval minutes.
 <br><br>
 Questions/comments/suggestions on netwatch-${version} can be directed to <a href="mailto:$email_address">$email_address</a>
 </BODY></HTML>
EOF

exit();


sub NiceDate {
# This isn't used ... could be removed ...
  my($date) = @_;
  my($newdate, $year, $month, $day);
  ($year, $month, $day) = split(/\//, $date);
  $newdate = "$month/";
  $newdate .= "$day/" if $day;
  $newdate .= "$year";
}


sub ReadParse {
# HTML parsing ...
   if (@_) { local (*in) = @_; }
   local ($i, $loc, $key, $val);
   # Read in text
   if ($ENV{'REQUEST_METHOD'} eq "GET") {
      $in = $ENV{'QUERY_STRING'};
   } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
         $in .= getc;  }
   }
   @in = split(/&/,$in);
   foreach $i (0 .. $#in) {
      # Convert plus's to spaces
      $_ = $in[$i];
      $in[$i] = &sanitize($_);
      $in[$i] =~ s/\+/ /g;
      # Convert %XX from hex numbers to alphanumeric
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
      # Split into key and value.
      $loc = index($in[$i],"=");
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
  }
}


# Added per CERT advistory - send Alek EMail if you want changes here ...
sub sanitize {
   # This is opened up a bit 'cause we want to allow Perl regular expressions ...
   local ($OK_CHARS);
   $OK_CHARS='-a-zA-Z0-9_.@=/?+[]* \s';
   s/[^$OK_CHARS]/_/go;
   return $_;
}




